# Syringe #

Syringe is a dependency injection library, inspired by the Spring framework's 
dependency injection functionality.  Its goals are to be self contained, easy 
to use, and easy to extend. 

## Self Contained ##

The Spring framework is an excellent tool for accomplishing all sorts of tasks. 
However -- and this may be simply due to faulty research on my part -- it is fairly
difficult to break out certain sections of the framework when you want to work with
part A and not parts B-Z. 

With Syringe, the goal is to eliminate external dependencies completely -- or as much
as reasonably possible.  Even the ubiquitous log4j is missing, and the library is using
the java.util.logging API (and even this might be removed eventually; it's used now
mainly for debugging purposes).

## Ease of Use ##

Setting up dependency injection should not be a mind numbing task.  The goal of Syringe
is to make it quite simple: configure the dependencies to create ("beans" in Spring land),
and request those dependencies in your code.

*Note: An equivalent of Spring's AutoWiring feature may be considered in the future, but
for now its being intentionally left out.  While an awesome tool when used correctly, it's
too easy to make projects difficult to maintain.*

## Extensibility ##

At present, the primary extensibility point is planned on being the context loading. 
The initial version will have support for XML-based context files -- possibly .properties
files as well.  Perhaps you'll have a different idea for how to configure your system;
you should be able to work with that.  Other aspects may lead themselves to easy 
extensibility in the future, too, but it's a little difficult to consider what when
the project is still in its infancy.

# License #

No official license (i.e. LGPL, GNU, Apache, etc.) has been selected yet, but it'll be
as unrestrictive as possible.  The gist will break down to "use it for whatever you like,
but don't claim it as your own."  If one of the more popular licenses will work with that,
then that's the one we'll use; otherwise, probably just write a license document that turns 
the above statement into an actual sentence.