/**
 * 
 */
package net.javamonkey.syringe.models;

/**
 * Represents an argument to a {@link Factory} or constructor.
 * 
 * @author Matthew Cory
 * 
 */
public final class Argument {

	/**
	 * Gets the argument index.  The index represents the order in which
	 * the argument is passed to the method.
	 * 
	 * @return the argument index.
	 */
	public int getIndex() {
		return index;
	}

	/**
	 * Sets the argument index.  The index represents the order in which
	 * the argument is passed to the method.
	 * 
	 * @param index the argument index.
	 */
	public void setIndex(final int index) {
		this.index = index;
	}

	public String getStrValue() {
		return strValue;
	}

	public void setStrValue(final String strValue) {
		this.strValue = strValue;
	}

	public String getRefId() {
		return refId;
	}

	public void setRefId(final String refId) {
		this.refId = refId;
	}

	private int index;
	private String strValue;
	private String refId;
}
