/**
 * 
 */
package net.javamonkey.syringe.models;

import java.util.ArrayList;
import java.util.Collection;

/**
 * Represents a dependency in the dependency descriptor.
 * 
 * @author Matthew Cory
 * 
 */
public final class Dependency {

	public String getId() {
		return id;
	}

	public void setId(final String id) {
		this.id = id;
	}

	public String getClassName() {
		return className;
	}

	public void setClassName(final String className) {
		this.className = className;
	}
	
	public boolean isSingleton() {
		return singleton;
	}
	
	public void setSingleton(final boolean singleton) {
		this.singleton = singleton;
	}

	public Collection<Argument> getCtorArguments() {
		return ctorArguments;
	}

	public void setCtorArguments(final Collection<Argument> ctorArguments) {
		this.ctorArguments = ctorArguments;
	}

	public void addConstructorArgument(final Argument constructorArgument) {
		if (ctorArguments == null) {
			ctorArguments = new ArrayList<Argument>();
		}

		ctorArguments.add(constructorArgument);
	}

	public boolean hasConstructorArgs() {
		return ((this.ctorArguments != null) && (this.ctorArguments.size() > 0));
	}

	public Collection<Property> getProperties() {
		return properties;
	}

	public void setProperties(final Collection<Property> properties) {
		this.properties = properties;
	}

	public void addProperty(final Property property) {
		if (properties == null) {
			properties = new ArrayList<Property>();
		}

		properties.add(property);
	}

	public Factory getFactory() {
		return factory;
	}

	public void setFactory(Factory factory) {
		this.factory = factory;
	}
	
	public boolean hasFactory() {
		return (this.factory != null);
	}

	private String id;
	private String className;
	private boolean singleton;
	private Collection<Argument> ctorArguments;
	private Collection<Property> properties;
	private Factory factory;
	
}
