/**
 * 
 */
package net.javamonkey.syringe.models;

import java.util.ArrayList;
import java.util.Collection;

/**
 * @author Matthew Cory
 * 
 */
public final class Factory {

	public String getClassName() {
		return className;
	}

	public void setClassName(String className) {
		this.className = className;
	}

	public String getMethodName() {
		return methodName;
	}

	public void setMethodName(String methodName) {
		this.methodName = methodName;
	}

	public Collection<Argument> getArguments() {
		return arguments;
	}

	public void setArguments(Collection<Argument> arguments) {
		this.arguments = arguments;
	}
	
	public void addArgument(final Argument argument) {
		if (arguments == null) {
			arguments = new ArrayList<Argument>();
		}

		arguments.add(argument);
	}
	
	public boolean hasArguments() {
		return ((arguments != null) && (arguments.size() > 0));
	}

	private String className;
	private String methodName;
	private Collection<Argument> arguments;
}
