/**
 * 
 */
package net.javamonkey.syringe.xml;

import net.javamonkey.syringe.models.Argument;
import net.javamonkey.syringe.models.Dependency;
import org.w3c.dom.Element;

/**
 * @author Matthew
 *
 */
final class XmlCtorArgumentBuilder implements XmlChildBuilder {

	/* (non-Javadoc)
	 * @see net.javamonkey.syringe.xml.XmlChildBuilder#buildChild(net.javamonkey.syringe.models.Dependency, org.w3c.dom.Element)
	 */
	@Override
	public void buildChild(Dependency dependency, Element element) {
		final Argument arg = new Argument();
		
		final int argIdx;
		if (dependency.hasConstructorArgs()) {
			argIdx = dependency.getCtorArguments().size();
		} else {
			argIdx = 0;
		}
		
		arg.setIndex(argIdx);
		arg.setStrValue(element.getAttribute("value"));
		
		dependency.addConstructorArgument(arg);
	}

}
