/**
 * 
 */
package net.javamonkey.syringe.test;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.logging.LogManager;
import org.junit.BeforeClass;

/**
 * Provides a base class for test suites that
 * require log4j configuration.
 * 
 * @author Matthew Cory
 *
 */
public abstract class LoggedTest {

	@BeforeClass
	public static void configureLogging() throws IOException {
		final InputStream ins = new FileInputStream("target/test-classes/logger.properties");
		LogManager.getLogManager().readConfiguration(ins);
	}

	protected LoggedTest() {
	}
}
