/**
 * 
 */
package net.javamonkey.syringe.test.utils;

/**
 * Factory class for generating FactoryItem objects for testing factory method
 * initialization.
 * 
 * @author Matthew Cory
 * 
 */
public final class FactoryItemFactory {

	public static FactoryItem createFactoryItem(final String str, final double dbl) {
		final FactoryItem res = new FactoryItem();

		res.setaDouble(dbl);
		res.setaString(str);

		factoryMethodCalled = true;
		return res;
	}

	public static boolean isFactoryMethodCalled() {
		return factoryMethodCalled;
	}

	public static void resetFactoryMethodCalled() {
		FactoryItemFactory.factoryMethodCalled = false;
	}

	private static boolean factoryMethodCalled = false;
}
